package org.apidesign.apifest08.test;
import static junit.framework.Assert.assertEquals;
import static org.apidesign.apifest08.currency.MoneyImpl.money;
import static org.apidesign.apifest08.test.Task1Test.CZK;
import static org.apidesign.apifest08.test.Task1Test.USD;

import java.math.BigDecimal;

import org.apidesign.apifest08.currency.Convertor;
import org.apidesign.apifest08.currency.Money;
import org.junit.Test;

public class OnlineConvertorTest {
	private static final Money ONE_USD = money(1, USD);

	@Test
	public void testBounce()
	{
		Convertor c = Task3Test.createOnlineCZKUSDConvertor();
		
		doBounceTest(c);
		doBounceTest(c);
	
	}

	private void doBounceTest(Convertor c) {
		BigDecimal expectedRate = new BigDecimal(16);
		BigDecimal increment = new BigDecimal("0.01");
		
		for (int i=0;i<100;i++)
		{
			assertEquals(money(expectedRate,CZK), c.convert(ONE_USD, CZK));
			expectedRate = expectedRate.subtract(increment);
		}
		
		assertEquals(money(15,CZK), c.convert(ONE_USD, CZK));
		
		for (int i=0;i<99;i++)
		{
			expectedRate = expectedRate.add(increment);
			assertEquals(money(expectedRate,CZK), c.convert(ONE_USD, CZK));
		}
	}
}
